close all;
clear all;


ti = [0:0.05:1, 1.1:0.1:2, 2.2:0.15:3, 3.15:0.2:4, 4.2:0.25:(2*pi)] ;
ti = ti';
ti = ti(2:end);

P = [cos(ti), sin(ti)];
N_P = -P;
P = P/3 + 0.5;


T = QuadTree(P, []);
l = 1:numel(ti);
l = l';
D = 3;
w_p = arrayfun(@(x) W(P, T, D, x), l);
depths_p = DesiredDepths(T.getMaxDepth(), w_p);

T.loadV(P, w_p, depths_p, N_P);

% We show with plotV the vector on the nodes.
figure(1);
hold on;

scatter(P(:,1), P(:,2));
quiver(P(:,1), P(:,2), N_P(:, 1), N_P(:,2), 0.5);

T.plot();
T.plotV();

stem3(P(:,1), P(:,2), w_p);

axis([0,1, 0, 1]);
axis square;
hold off;



% Now, we plot the vector field on the grid.
% As the function V is not used eventually, it has not been optimized at
% all...
figure(2);
hold on;
scatter(P(:,1), P(:,2));
quiver(P(:,1), P(:,2), N_P(:, 1), N_P(:,2), 0.5);

T.plot();
[X,Y] = meshgrid(0:0.02:1, 0:0.02:1);
f = @(x,y) V(P, N_P, T, w_p, depths_p, [x,y]);
C = arrayfun(f, X, Y, 'UniformOutput', 0);
U = cellfun(@(x) x(1), C);
V = cellfun(@(x) x(2), C);

quiver(X, Y, U, V, 3);



stem3(P(:,1), P(:,2), w_p);

axis([0,1, 0, 1]);
axis square;
hold off;

% 




