close all;
clear all;

P = [[0.2, 0.3];...
    [0.6, 0.6];...
    [0.6, 0.7];...
    [0.45, 0.6];...
    [0.8, 0.6];...
    [0.7, 0.57];...
    [0.85, 0.55]];

T = QuadTree(P, []);

%% simple plot
figure(1);
hold on;
scatter(P(:,1), P(:,2), 'x', 'k');
T.plot();

axis([0,1, 0, 1]);
axis square;
hold off;

%% example of a function
figure(2);
hold on;
scatter(P(:,1), P(:,2), 'x', 'k');
T.plot();

s = T.getNode([4, 1]);
[X,Y] = meshgrid(0:0.01:1, 0:0.01:1);

surf(X, Y, +arrayfun(@s.fun, X, Y) - 9, 'EdgeColor','none');
view(2);

axis([0,1, 0, 1]);
axis square;
hold off;

figure(3);
hold on;
x = -2:0.01:2;
plot(x, arrayfun(@order2BSpline, x), 'Linewidth',  3);
grid on;
axis equal;
hold off;



